﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Warensoft.Socket
{
    public class Application
    {
        private Dictionary<string, object> properties = new Dictionary<string, object>();
        public object this[string name]
        {
            get
            {
                return this.properties[name];
            }
            set
            {
                lock (this)
                {
                    this.properties[name] = value;
                }
            }
        }
    }
}
