﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Warensoft.Socket;
//using Warensoft.PythonExtension;

namespace Warensoft.SocketImplementation
{
    public class WarensoftChannel:Channel
    {
        dynamic pythonObject;
        public WarensoftChannel(string name, dynamic pythonObject,Warensoft.Socket.SocketServer server)
            : base(name,server)
        {
            this.pythonObject = pythonObject;
           
        }
        public WarensoftSocketServer Server
        {
            get
            {
                return this.server as WarensoftSocketServer;
            }
        }
        public override void OnSessionRemoved(ClientSessionBase session)
        {
            this.Server.ChannelPyLoader.CallbackObject.OnSessionRemoved(session,this,this.server );
        }

        protected override void OnRoomEmpty()
        {
            this.Server.ChannelPyLoader.CallbackObject.OnRoomEmpty(this, this.server);
        }
    }
}
