# coding=gb2312
import clr
import sys
clr.AddReference("System.ServiceModel")
clr.AddReference("Warensoft.SocketImplementation")
clr.AddReference("System.Windows.Forms")
from System.Windows.Forms import MessageBox
import clrtype
from System import Console, Uri, Exception
from System.ServiceModel.Description import ServiceDescription, ServiceDebugBehavior, ServiceThrottlingBehavior
from Warensoft.SocketImplementation import WarensoftSocketServer
from System.ServiceModel import (ServiceContractAttribute,
                                 OperationContractAttribute,
                                 ServiceHost, WSHttpBinding, NetTcpBinding, NetNamedPipeBinding,
                                 ServiceBehaviorAttribute,
                                 )
OperationContract = clrtype.attribute(OperationContractAttribute)
class IGameSocketService(object):
    __metaclass__ = clrtype.ClrInterface#Ϊӿ
    _clrnamespace = "TestWCF"#ռ
    _clrclassattribs = [ServiceContractAttribute]#ΪISerivceӿServiceContractAttribute
    @OperationContract()
    @clrtype.accepts()
    @clrtype.returns()
    def ReloadPython(self):
        raise RuntimeError("this should not get called")
    @OperationContract()
    @clrtype.accepts()
    @clrtype.returns(int)
    def GetSessionCount(self):
        raise RuntimeError("this should not get called")
Server = None
service = None
class GameSocketService(IGameSocketService):
    __metaclass__ = clrtype.ClrClass
    _clrnamespace = "TestWcf"
    _clrclassattribs = [ServiceBehaviorAttribute]

    def ReloadPython(self):
        Server.LoadPython()
    def GetSessionCount(self):
        try:
            count = Server.UserList.Count
        except Exception, ex:
            raise RuntimeError(ex.Message)
        return Server.UserList.Count
        #return 0
def StartService():
    #MessageBox.Show(sys.path.__str__())
    service = ServiceHost(clr.GetClrType(GameSocketService), Uri("net.tcp://localhost:8088/GameSocketService"))
    service.AddServiceEndpoint(clr.GetClrType(IGameSocketService), NetTcpBinding(), "")
    behavior = service.Description.Behaviors[clr.GetClrType(ServiceDebugBehavior)]
    behavior.IncludeExceptionDetailInFaults = True
    stb = ServiceThrottlingBehavior()
    stb.MaxConcurrentCalls = 50000000
    stb.MaxConcurrentInstances = 50000000
    stb.MaxConcurrentSessions = 50000000
    service.Description.Behaviors.Add(stb)
    service.Open()
def StopService():
    service.Close()



