﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Warensoft.PythonExtension
{
    /// <summary>
    /// Python加载器的基类
    /// </summary>
    public abstract class IpyLoaderBase
    {
        /// <summary>
        /// 当脚本被加载时触发
        /// </summary>
        public event EventHandler ScriptLoaded;
        /// <summary>
        /// 加载脚本
        /// </summary>
        public abstract void Load();

        /// <summary>
        /// 
        /// </summary>
        protected void OnScriptLoaded()
        {
            if (this.ScriptLoaded !=null )
            {
                this.ScriptLoaded(this,new EventArgs ());
            }
        }
    }
}
