﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Warensoft.Utility
{
    /// <summary>
    /// Composite reture value
    /// </summary>
    public struct ResultInfo
    {
        /// <summary>
        /// set or get the message of return value
        /// </summary>
        public string Message
        {
            get;
            set;
        }
        /// <summary>
        /// indicates whether the operation is correctedly done
        /// </summary>
        public bool OperationDone
        {
            get;
            set;
        }
        public object AdditionalData
        {
            get;
            set;
        }
    }
    public struct ResultInfo<T>
    {
        /// <summary>
        /// set or get the message of return value
        /// </summary>
        public string Message
        {
            get;
            set;
        }
        /// <summary>
        /// indicates whether the operation is correctedly done
        /// </summary>
        public bool OperationDone
        {
            get;
            set;
        }
        public T AdditionalData
        {
            get;
            set;
        }
    }
}
